'****************************************************************
'*  Name    : PPS_18FxxK40.inc                                  *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2017 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 06/02/2017                                        *
'*  Version : 1.0                                               *
'*  Notes   : PPS library for PIC18FxxK40 series                *
'*  Devices available: 18F24K40,18F25K40,18F27K40,18F45K40      *
'*  18F46K40,18F47K40,18F65K40,18F66K40,18F67K40                *
'****************************************************************

$ifndef __PPS_INC_
$define __PPS_INC_
'-------------------------------------------------------------------------------
' PPS Pin Inputs
'
$define cIn_Pin_RP0  0           ' Assign RA0 As Input Pin
$define cIn_Pin_RP1  1           ' Assign RA1 As Input Pin
$define cIn_Pin_RP2  2           ' Assign RA2 As Input Pin
$define cIn_Pin_RP3  3           ' Assign RA3 As Input Pin
$define cIn_Pin_RP4  4           ' Assign RA4 As Input Pin
$define cIn_Pin_RP5  5           ' Assign RA5 As Input Pin
$define cIn_Pin_RP6  6           ' Assign RA6 As Input Pin
$define cIn_Pin_RP7  7           ' Assign RA7 As Input Pin

$define cIn_Pin_RP8  8           ' Assign RB0 As Input Pin
$define cIn_Pin_RP9  9           ' Assign RB1 As Input Pin
$define cIn_Pin_RP10 10          ' Assign RB2 As Input Pin
$define cIn_Pin_RP11 11          ' Assign RB3 As Input Pin
$define cIn_Pin_RP12 12          ' Assign RB4 As Input Pin
$define cIn_Pin_RP13 13          ' Assign RB5 As Input Pin
$define cIn_Pin_RP14 14          ' Assign RB6 As Input Pin
$define cIn_Pin_RP15 15          ' Assign RB7 As Input Pin

$define cIn_Pin_RP16 16          ' Assign RC0 As Input Pin
$define cIn_Pin_RP17 17          ' Assign RC1 As Input Pin
$define cIn_Pin_RP18 18          ' Assign RC2 As Input Pin
$define cIn_Pin_RP19 19          ' Assign RC3 As Input Pin
$define cIn_Pin_RP20 20          ' Assign RC4 As Input Pin
$define cIn_Pin_RP21 21          ' Assign RC5 As Input Pin
$define cIn_Pin_RP22 22          ' Assign RC6 As Input Pin
$define cIn_Pin_RP23 23          ' Assign RC7 As Input Pin

$if (_device = _18F45K40) Or (_device = _18F46K40) Or (_device = _18F47K40) Or (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cIn_Pin_RP24 24          ' Assign RD0 As Input Pin
$define cIn_Pin_RP25 25          ' Assign RD1 As Input Pin
$define cIn_Pin_RP26 26          ' Assign RD2 As Input Pin
$define cIn_Pin_RP27 27          ' Assign RD3 As Input Pin
$define cIn_Pin_RP28 28          ' Assign RD4 As Input Pin
$define cIn_Pin_RP29 29          ' Assign RD5 As Input Pin
$define cIn_Pin_RP30 30          ' Assign RD6 As Input Pin
$define cIn_Pin_RP31 31          ' Assign RD7 As Input Pin

$define cIn_Pin_RP32 32          ' Assign RE0 As Input Pin
$define cIn_Pin_RP33 33          ' Assign RE1 As Input Pin
$define cIn_Pin_RP34 34          ' Assign RE2 As Input Pin
$endif

$if (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cIn_Pin_RP35 35          ' Assign RE3 As Input Pin
$define cIn_Pin_RP36 36          ' Assign RE4 As Input Pin
$define cIn_Pin_RP37 37          ' Assign RE5 As Input Pin
$define cIn_Pin_RP38 38          ' Assign RE6 As Input Pin
$define cIn_Pin_RP39 39          ' Assign RE7 As Input Pin

$define cIn_Pin_RP40 40          ' Assign RF0 As Input Pin
$define cIn_Pin_RP41 41          ' Assign RF1 As Input Pin
$define cIn_Pin_RP42 42          ' Assign RF2 As Input Pin
$define cIn_Pin_RP43 43          ' Assign RF3 As Input Pin
$define cIn_Pin_RP44 44          ' Assign RF4 As Input Pin
$define cIn_Pin_RP45 45          ' Assign RF5 As Input Pin
$define cIn_Pin_RP46 46          ' Assign RF6 As Input Pin
$define cIn_Pin_RP47 47          ' Assign RF7 As Input Pin

$define cIn_Pin_RP48 48          ' Assign RG0 As Input Pin
$define cIn_Pin_RP49 49          ' Assign RG1 As Input Pin
$define cIn_Pin_RP50 50          ' Assign RG2 As Input Pin
$define cIn_Pin_RP51 51          ' Assign RG3 As Input Pin
$define cIn_Pin_RP52 52          ' Assign RG4 As Input Pin
$define cIn_Pin_RP53 53          ' Assign RG5 As Input Pin
$define cIn_Pin_RP54 54          ' Assign RG6 As Input Pin
$define cIn_Pin_RP55 55          ' Assign RG7 As Input Pin

$define cIn_Pin_RP56 56          ' Assign RH0 As Input Pin
$define cIn_Pin_RP57 57          ' Assign RH1 As Input Pin
$define cIn_Pin_RP58 58          ' Assign RH2 As Input Pin
$define cIn_Pin_RP59 59          ' Assign RH3 As Input Pin
$endif
'-------------------------------------------------------------------------------
' PPS Pin Inputs
'
$define cIn_Pin_RA0  0           ' Assign RA0 As Input Pin
$define cIn_Pin_RA1  1           ' Assign RA1 As Input Pin
$define cIn_Pin_RA2  2           ' Assign RA2 As Input Pin
$define cIn_Pin_RA3  3           ' Assign RA3 As Input Pin
$define cIn_Pin_RA4  4           ' Assign RA4 As Input Pin
$define cIn_Pin_RA5  5           ' Assign RA5 As Input Pin
$define cIn_Pin_RA6  6           ' Assign RA6 As Input Pin
$define cIn_Pin_RA7  7           ' Assign RA7 As Input Pin

$define cIn_Pin_RB0  8           ' Assign RB0 As Input Pin
$define cIn_Pin_RB1  9           ' Assign RB1 As Input Pin
$define cIn_Pin_RB2 10           ' Assign RB2 As Input Pin
$define cIn_Pin_RB3 11           ' Assign RB3 As Input Pin
$define cIn_Pin_RB4 12           ' Assign RB4 As Input Pin
$define cIn_Pin_RB5 13           ' Assign RB5 As Input Pin
$define cIn_Pin_RB6 14           ' Assign RB6 As Input Pin
$define cIn_Pin_RB7 15           ' Assign RB7 As Input Pin

$define cIn_Pin_RC0 16          ' Assign RC0 As Input Pin
$define cIn_Pin_RC1 17          ' Assign RC1 As Input Pin
$define cIn_Pin_RC2 18          ' Assign RC2 As Input Pin
$define cIn_Pin_RC3 19          ' Assign RC3 As Input Pin
$define cIn_Pin_RC4 20          ' Assign RC4 As Input Pin
$define cIn_Pin_RC5 21          ' Assign RC5 As Input Pin
$define cIn_Pin_RC6 22          ' Assign RC6 As Input Pin
$define cIn_Pin_RC7 23          ' Assign RC7 As Input Pin

$if (_device = _18F45K40) Or (_device = _18F46K40) Or (_device = _18F47K40) Or (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cIn_Pin_RD0 24          ' Assign RD0 As Input Pin
$define cIn_Pin_RD1 25          ' Assign RD1 As Input Pin
$define cIn_Pin_RD2 26          ' Assign RD2 As Input Pin
$define cIn_Pin_RD3 27          ' Assign RD3 As Input Pin
$define cIn_Pin_RD4 28          ' Assign RD4 As Input Pin
$define cIn_Pin_RD5 29          ' Assign RD5 As Input Pin
$define cIn_Pin_RD6 30          ' Assign RD6 As Input Pin
$define cIn_Pin_RD7 31          ' Assign RD7 As Input Pin

$define cIn_Pin_RE0 32          ' Assign RE0 As Input Pin
$define cIn_Pin_RE1 33          ' Assign RE1 As Input Pin
$define cIn_Pin_RE2 34          ' Assign RE2 As Input Pin
$endif

$if (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cIn_Pin_RE3 35          ' Assign RE3 As Input Pin
$define cIn_Pin_RE4 36          ' Assign RE4 As Input Pin
$define cIn_Pin_RE5 37          ' Assign RE5 As Input Pin
$define cIn_Pin_RE6 38          ' Assign RE6 As Input Pin
$define cIn_Pin_RE7 39          ' Assign RE7 As Input Pin

$define cIn_Pin_RF0 40          ' Assign RF0 As Input Pin
$define cIn_Pin_RF1 41          ' Assign RF1 As Input Pin
$define cIn_Pin_RF2 42          ' Assign RF2 As Input Pin
$define cIn_Pin_RF3 43          ' Assign RF3 As Input Pin
$define cIn_Pin_RF4 44          ' Assign RF4 As Input Pin
$define cIn_Pin_RF5 45          ' Assign RF5 As Input Pin
$define cIn_Pin_RF6 46          ' Assign RF6 As Input Pin
$define cIn_Pin_RF7 47          ' Assign RF7 As Input Pin

$define cIn_Pin_RG0 48          ' Assign RG0 As Input Pin
$define cIn_Pin_RG1 49          ' Assign RG1 As Input Pin
$define cIn_Pin_RG2 50          ' Assign RG2 As Input Pin
$define cIn_Pin_RG3 51          ' Assign RG3 As Input Pin
$define cIn_Pin_RG4 52          ' Assign RG4 As Input Pin
$define cIn_Pin_RG5 53          ' Assign RG5 As Input Pin
$define cIn_Pin_RG6 54          ' Assign RG6 As Input Pin
$define cIn_Pin_RG7 55          ' Assign RG7 As Input Pin

$define cIn_Pin_RH0 56          ' Assign RH0 As Input Pin
$define cIn_Pin_RH1 57          ' Assign RH1 As Input Pin
$define cIn_Pin_RH2 58          ' Assign RH2 As Input Pin
$define cIn_Pin_RH3 59          ' Assign RH3 As Input Pin
$endif
'-------------------------------------------------------------------------------
' PPS Function Inputs
'
$if (_device = _18F24K40) Or (_device = _18F25K40)
$define cIn_Fn_INT0         INT0PPS     ' Assign External Interrupt 0 Input (INTR0) to the corresponding RPn pPin
$define cIn_Fn_INT1         INT1PPS     ' Assign External Interrupt 1 Input (INTR1) to the corresponding RPn pPin
$define cIn_Fn_INT2         INT2PPS     ' Assign External Interrupt 2 Input (INTR2) to the corresponding RPn pPin
$define cIn_Fn_T0CK         T0CKIPPS    ' Assign Timer0 Clock input(TMR0) to the corresponding RPn pPin
$define cIn_Fn_T1CK         T1CKIPPS    ' Assign Timer1 Clock input(TMR1) to the corresponding RPn pPin
$define cIn_Fn_T1G          T1GPPS      ' Assign Timer0 Gate input(GATE1) to the corresponding RPn pPin
$define cIn_Fn_T3CK         T3CKIPPS    ' Assign Timer3 Clock input(TMR3) to the corresponding RPn pPin
$define cIn_Fn_T3G          T3GPPS      ' Assign Timer3 Gate input(GATE3) to the corresponding RPn pPin
$define cIn_Fn_T5CK         T5CKIPPS    ' Assign Timer5 Clock input(TMR5) to the corresponding RPn pPin
$define cIn_Fn_T5G          T5GPPS      ' Assign Timer5 Gate input(GATE5) to the corresponding RPn pPin
$define cIn_Fn_T2CK         T2INPPS     ' Assign Timer2 Clock input(TMR2) to the corresponding RPn pPin
$define cIn_Fn_T4CK         T4INPPS     ' Assign Timer4 Clock input(TMR4) to the corresponding RPn pPin
$define cIn_Fn_T6CK         T6INPPS     ' Assign Timer4 Clock input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_CCP1         CCP1PPS     ' CCP1 input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_CCP2         CCP2PPS     ' CCP2 input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_CWG1         CWG1PPS     ' CWG1 input(x) to the corresponding RPn pPin
$define cIn_Fn_DSMCL        MDCARLPPS   ' DSM Carrier Low input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_DSMCH        MDCARHPPS   ' DSM Carrier High input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_DSMS         MDSRCPPS    ' Assign DSM Source input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_ADC_CT       ADACTPPS    ' Assign ADC Conversion Trigger Input (TMR6) to the corresponding RPn pPin
$define cIn_Fn_MSSP1CK      SSP1CLKPPS  ' MSSP1 Clock Input (TMR6) to the corresponding RPn pPin
$define cIn_Fn_MSSP1DAT     SSP1DATPPS  ' MSSP1 Data Input (TMR6) to the corresponding RPn pPin
$define cIn_Fn_MSSP1SL      SSP1SSPPS   ' MSSP1 Slave Select Input (MSSP1SL) to the corresponding RPn pPin
$define cIn_Fn_RX1DT1       RX1PPS      ' Assign EUSART1 Synchronous/Asynchronous Receive (RX1/DT1) To the corresponding RPn pPin
$define cIn_Fn_TX1CK1       TX1PPS      ' Assign EUSART1 Synchronous/Asynchronous Receive (TX1/CK1) To the corresponding RPn pPin
$endif
'-------------------------------------------------------------------------------
' PPS Function Inputs
'
$if (_device = _18F27K40) Or (_device = _18F47K40)  Or (_device = _18F26K40) Or (_device = _18F45K40) Or (_device = _18F46K40) Or (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cIn_Fn_INT0         INT0PPS     ' Assign External Interrupt 0 Input (INTR0) to the corresponding RPn pPin
$define cIn_Fn_INT1         INT1PPS     ' Assign External Interrupt 1 Input (INTR1) to the corresponding RPn pPin
$define cIn_Fn_INT2         INT2PPS     ' Assign External Interrupt 2 Input (INTR2) to the corresponding RPn pPin
$define cIn_Fn_T0CK         T0CKIPPS    ' Assign Timer0 Clock input(TMR0) to the corresponding RPn pPin
$define cIn_Fn_T1CK         T1CKIPPS    ' Assign Timer1 Clock input(TMR1) to the corresponding RPn pPin
$define cIn_Fn_T1G          T1GPPS      ' Assign Timer0 Gate input(GATE1) to the corresponding RPn pPin
$define cIn_Fn_T3CK         T3CKIPPS    ' Assign Timer3 Clock input(TMR3) to the corresponding RPn pPin
$define cIn_Fn_T3G          T3GPPS      ' Assign Timer3 Gate input(GATE3) to the corresponding RPn pPin
$define cIn_Fn_T5CK         T5CKIPPS    ' Assign Timer5 Clock input(TMR5) to the corresponding RPn pPin
$define cIn_Fn_T5G          T5GPPS      ' Assign Timer5 Gate input(GATE5) to the corresponding RPn pPin
$define cIn_Fn_T2CK         T2INPPS     ' Assign Timer2 Clock input(TMR2) to the corresponding RPn pPin
$define cIn_Fn_T4CK         T4INPPS     ' Assign Timer4 Clock input(TMR4) to the corresponding RPn pPin
$define cIn_Fn_T6CK         T6INPPS     ' Assign Timer4 Clock input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_CCP1         CCP1PPS     ' CCP1 input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_CCP2         CCP2PPS     ' CCP2 input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_CWG1         CWG1PPS     ' CWG1 input(x) to the corresponding RPn pPin
$define cIn_Fn_DSMCL        MDCARLPPS   ' DSM Carrier Low input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_DSMCH        MDCARHPPS   ' DSM Carrier High input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_DSMS         MDSRCPPS    ' Assign DSM Source input(TMR6) to the corresponding RPn pPin
$define cIn_Fn_ADC_CT       ADACTPPS    ' Assign ADC Conversion Trigger Input (TMR6) to the corresponding RPn pPin
$define cIn_Fn_MSSP1CK      SSP1CLKPPS  ' MSSP1 Clock Input (TMR6) to the corresponding RPn pPin
$define cIn_Fn_MSSP1DAT     SSP1DATPPS  ' MSSP1 Data Input (TMR6) to the corresponding RPn pPin
$define cIn_Fn_MSSP1SL      SSP1SSPPS   ' MSSP1 Slave Select Input (MSSP1SL) to the corresponding RPn pPin
$define cIn_Fn_MSSP2CK      SSP2CLKPPS  ' MSSP2 Clock Input (TMR6) to the corresponding RPn pPin
$define cIn_Fn_MSSP2DAT     SSP2DATPPS  ' MSSP2 Data Input (TMR6) to the corresponding RPn pPin
$define cIn_Fn_MSSP2SL      SSP2SSPPS   ' MSSP2 Slave Select Input (MSSP2SL) to the corresponding RPn pPin
$define cIn_Fn_RX1DT1       RX1PPS      ' Assign EUSART1 Synchronous/Asynchronous Receive (RX1/DT1) To the corresponding RPn pPin
$define cIn_Fn_TX1CK1       TX1PPS      ' Assign EUSART1 Synchronous/Asynchronous Receive (TX1/CK1) To the corresponding RPn pPin
$define cIn_Fn_RX2DT2       RX2PPS      ' Assign EUSART2 Synchronous/Asynchronous Receive (RX2/DT2) To the corresponding RPn pPin
$define cIn_Fn_TX2CK2       TX2PPS      ' Assign EUSART2 Synchronous/Asynchronous Receive (TX2/CK2) To the corresponding RPn pPin
$endif

$if (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cIn_Fn_INT3         INT3PPS     ' Assign External Interrupt 3 Input (INTR3) to the corresponding RPn pPin
$define cIn_Fn_T7CK         T7CKIPPS    ' Assign Timer7 Clock input(TMR7) to the corresponding RPn pPin
$define cIn_Fn_T7G          T7GPPS      ' Assign Timer7 Gate input(GATE7) to the corresponding RPn pPin
$define cIn_Fn_T8CK         T8INPPS     ' Assign Timer8 Clock input(TMR8) to the corresponding RPn pPin
$define cIn_Fn_CCP3         CCP3PPS     ' CCP3 input(TMRX) to the corresponding RPn pPin
$define cIn_Fn_CCP4         CCP4PPS     ' CCP4 input(TMRX) to the corresponding RPn pPin
$define cIn_Fn_CCP5         CCP5PPS     ' CCP5 input(TMRX) to the corresponding RPn pPin
$define cIn_Fn_SMT1W        SMT1WINPPS  ' SMT1 Window to the corresponding RPn pPin
$define cIn_Fn_SMT1S        SMT1SIGPPS  ' SMT1 Signal to the corresponding RPn pPin
$define cIn_Fn_SMT2W        SMT2WINPPS  ' SMT2 Window to the corresponding RPn pPin
$define cIn_Fn_SMT2S        SMT2SIGPPS  ' SMT2 Signal to the corresponding RPn pPin
$define cIn_Fn_RX3DT3       RX3PPS      ' Assign EUSART3 Synchronous/Asynchronous Receive (RX3/DT3) To the corresponding RPn pPin
$define cIn_Fn_TX3CK3       TX3PPS      ' Assign EUSART3 Synchronous/Asynchronous Receive (TX3/CK3) To the corresponding RPn pPin
$define cIn_Fn_RX4DT4       RX4PPS      ' Assign EUSART3 Synchronous/Asynchronous Receive (RX4/DT4) To the corresponding RPn pPin
$define cIn_Fn_TX4CK4       TX4PPS      ' Assign EUSART3 Synchronous/Asynchronous Receive (TX4/CK4) To the corresponding RPn pPin
$define cIn_Fn_RX5DT5       RX5PPS      ' Assign EUSART3 Synchronous/Asynchronous Receive (RX5/DT5) To the corresponding RPn pPin
$define cIn_Fn_TX5CK5       TX5PPS      ' Assign EUSART3 Synchronous/Asynchronous Receive (TX5/CK5) To the corresponding RPn pPin
$endif
'-------------------------------------------------------------------------------
' PPS Function Ouputs
'
$if (_device = _18F24K40) Or (_device = _18F25K40)
$define cOut_Fn_ADGRDB  23  ' ADGRDB   ; 1 0111; RPn tied to ADGRDB
$define cOut_Fn_ADGRDA  22  ' ADGRDA   ; 1 0110; RPn tied to ADGRDA
$define cOut_Fn_DSM     21  ' DSM      ; 1 0101; RPn tied to DSM Carrier 
$define cOut_Fn_CLKR    20  ' CLKR     ; 1 0100; RPn tied to CLKR 
$define cOut_Fn_TMR0    19  ' TMR0     ; 1 0011; RPn tied to TMR0 Output 
$define cOut_Fn_SDO1    16  ' SDO1     ; 1 0000; RPn tied to SPI1 Data Output /  MSSP1 (SDO1/SDA1)
$define cOut_Fn_SCK1    15  ' SCK1     ; 0 1111; RPn tied to SPI1 Clock Output / MSSP1 (SCK1/SCL1)
$define cOut_Fn_CMP2    14  ' CMP2     ; 0 1110;
$define cOut_Fn_CMP1    13  ' CMP1     ; 0 1101;
$define cOut_Fn_RX1DT1  10  ' RX1      ; 0 1010; RPn tied to EUSART1 (RX) Asynchronous Receive / DT1
$define cOut_Fn_TX1CK1  9   ' TX1      ; 0 1001; RPn tied to EUSART1 (TX) Asynchronous Transmit / Asynchronous Clock Output
$define cOut_Fn_PWM4    8   ' PWM4     ; 0 1000; RPn tied to PWM4 output 
$define cOut_Fn_PWM3    7   ' PWM3     ; 0 0111; RPn tied to PWM3 output 
$define cOut_Fn_CCP2    6   ' CCP2     ; 0 0110; RPn tied to ECCP2/CCP2 compare or PWM output 
$define cOut_Fn_CCP1    5   ' CCP1     ; 0 0101; RPn tied to ECCP1/CCP1 compare or PWM output
$define cOut_Fn_C1DOUT  4   ' CWG1D    ; 0 0100; RPn tied to comparator 1D output
$define cOut_Fn_C1COUT  3   ' CWG1C    ; 0 0011; RPn tied to comparator 1C output
$define cOut_Fn_C1BOUT  2   ' CWG1B    ; 0 0010; RPn tied to comparator 1B output
$define cOut_Fn_C1AOUT  1   ' CWG1A    ; 0 0001; RPn tied to comparator 1A output
$define cOut_Fn_NULL    0   ' LATxy    ; 0 0000; RPn tied to default port pPin 
$endif
'-------------------------------------------------------------------------------
' PPS Function Ouputs
'
$if (_device = _18F27K40) Or (_device = _18F47K40)  Or (_device = _18F26K40) Or (_device = _18F45K40) Or (_device = _18F46K40)
$define cOut_Fn_ADGRDB  23  ' ADGRDB   ; 1 0111; RPn tied to ADGRDB
$define cOut_Fn_ADGRDA  22  ' ADGRDA   ; 1 0110; RPn tied to ADGRDA
$define cOut_Fn_DSM     21  ' DSM      ; 1 0101; RPn tied to DSM Carrier 
$define cOut_Fn_CLKR    20  ' CLKR     ; 1 0100; RPn tied to CLKR 
$define cOut_Fn_TMR0    19  ' TMR0     ; 1 0011; RPn tied to TMR0 Output 
$define cOut_Fn_SDO2    18  ' SDO2     ; 1 0010; RPn tied to SPI2 Data Output / MSSP2 (SDO2/SDA2)
$define cOut_Fn_SCK2    17  ' SCK2     ; 1 0001; RPn tied to SPI2 Clock Output / MSSP2 (SCK2/SCL2)
$define cOut_Fn_SDO1    16  ' SDO1     ; 1 0000; RPn tied to SPI1 Data Output /  MSSP1 (SDO1/SDA1)
$define cOut_Fn_SCK1    15  ' SCK1     ; 0 1111; RPn tied to SPI1 Clock Output / MSSP1 (SCK1/SCL1)
$define cOut_Fn_CMP2    14  ' CMP2     ; 0 1110;
$define cOut_Fn_CMP1    13  ' CMP1     ; 0 1101;
$define cOut_Fn_RX2DT2  12  ' RX2      ; 0 1100; RPn tied to EUSART2 (RX) Asynchronous Receive / DT1
$define cOut_Fn_TX2CK2  11  ' TX2      ; 0 1011; RPn tied to EUSART2 (TX) Asynchronous Transmit / Asynchronous Clock Output
$define cOut_Fn_RX1DT1  10  ' RX1      ; 0 1010; RPn tied to EUSART1 (RX) Asynchronous Receive / DT1
$define cOut_Fn_TX1CK1  9   ' TX1      ; 0 1001; RPn tied to EUSART1 (TX) Asynchronous Transmit / Asynchronous Clock Output
$define cOut_Fn_PWM4    8   ' PWM4     ; 0 1000; RPn tied to PWM4 output 
$define cOut_Fn_PWM3    7   ' PWM3     ; 0 0111; RPn tied to PWM3 output 
$define cOut_Fn_CCP2    6   ' CCP2     ; 0 0110; RPn tied to ECCP2/CCP2 compare or PWM output 
$define cOut_Fn_CCP1    5   ' CCP1     ; 0 0101; RPn tied to ECCP1/CCP1 compare or PWM output
$define cOut_Fn_C1DOUT  4   ' CWG1D    ; 0 0100; RPn tied to comparator 1D output
$define cOut_Fn_C1COUT  3   ' CWG1C    ; 0 0011; RPn tied to comparator 1C output
$define cOut_Fn_C1BOUT  2   ' CWG1B    ; 0 0010; RPn tied to comparator 1B output
$define cOut_Fn_C1AOUT  1   ' CWG1A    ; 0 0001; RPn tied to comparator 1A output
$define cOut_Fn_NULL    0   ' LATxy    ; 0 0000; RPn tied to default port pPin 
$endif
'-------------------------------------------------------------------------------
' PPS Function Ouputs
'
$if (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cOut_Fn_ADGRDB  33  ' ADGRDB   ; $21; RPn tied to ADGRDB
$define cOut_Fn_ADGRDA  32  ' ADGRDA   ; $20; RPn tied to ADGRDA
$define cOut_Fn_DSM1    31  ' DSM1     ; $1F; RPn tied to DSM1 Carrier 
$define cOut_Fn_CLKR    30  ' CLKR     ; $1E; RPn tied to CLKR 
$define cOut_Fn_TMR0    29  ' TMR0     ; $1D; RPn tied to TMR0 Output 
$define cOut_Fn_SDO2    28  ' SDO2     ; $1C; RPn tied to SPI2 Data Output / MSSP2 (SDO2/SDA2)
$define cOut_Fn_SCK2    27  ' SCK2     ; $1B; RPn tied to SPI2 Clock Output / MSSP2 (SCK2/SCL2)
$define cOut_Fn_SDO1    26  ' SDO1     ; $1A; RPn tied to SPI1 Data Output /  MSSP1 (SDO1/SDA1)
$define cOut_Fn_SCK1    25  ' SCK1     ; $19; RPn tied to SPI1 Clock Output / MSSP1 (SCK1/SCL1)
$define cOut_Fn_CMP3    24  ' CMP3     ; $18;
$define cOut_Fn_CMP2    23  ' CMP2     ; $17;
$define cOut_Fn_CMP1    22  ' CMP1     ; $16;
$define cOut_Fn_RX5DT5  21  ' RX5      ; $15; RPn tied to EUSART5 (RX) Asynchronous Receive / DT5
$define cOut_Fn_TX5CK5  20  ' TX5      ; $14; RPn tied to EUSART5 (TX) Asynchronous Transmit / Asynchronous Clock Output
$define cOut_Fn_RX4DT4  19  ' RX4      ; $13; RPn tied to EUSART4 (RX) Asynchronous Receive / DT4
$define cOut_Fn_TX4CK4  18  ' TX4      ; $12; RPn tied to EUSART4 (TX) Asynchronous Transmit / Asynchronous Clock Output
$define cOut_Fn_RX3DT3  17  ' RX3      ; $11; RPn tied to EUSART3 (RX) Asynchronous Receive / DT3
$define cOut_Fn_TX3CK3  16  ' TX3      ; $10; RPn tied to EUSART3 (TX) Asynchronous Transmit / Asynchronous Clock Output
$define cOut_Fn_RX2DT2  15  ' RX2      ; $0F; RPn tied to EUSART2 (RX) Asynchronous Receive / DT2
$define cOut_Fn_TX2CK2  14  ' TX2      ; $0E; RPn tied to EUSART2 (TX) Asynchronous Transmit / Asynchronous Clock Output
$define cOut_Fn_RX1DT1  13  ' RX2      ; $0D; RPn tied to EUSART1 (RX) Asynchronous Receive / DT1
$define cOut_Fn_TX1CK1  12  ' TX2      ; $0C; RPn tied to EUSART1 (TX) Asynchronous Transmit / Asynchronous Clock Output
$define cOut_Fn_PWM7    11  ' PWM7     ; $0B; RPn tied to PWM7 output 
$define cOut_Fn_PWM6    10  ' PWM6     ; $0A; RPn tied to PWM6 output
$define cOut_Fn_CCP5    9   ' CCP5     ; $09; RPn tied to ECCP5/CCP5 compare or PWM output
$define cOut_Fn_CCP4    8   ' CCP4     ; $08; RPn tied to ECCP4/CCP4 compare or PWM output
$define cOut_Fn_CCP3    7   ' CCP3     ; $07; RPn tied to ECCP3/CCP3 compare or PWM output
$define cOut_Fn_CCP2    6   ' CCP2     ; $06; RPn tied to ECCP2/CCP2 compare or PWM output
$define cOut_Fn_CCP1    5   ' CCP1     ; $05; RPn tied to ECCP1/CCP1 compare or PWM output
$define cOut_Fn_C1DOUT  4   ' CWG1D    ; $04; RPn tied to comparator 1D output 
$define cOut_Fn_C1COUT  3   ' CWG1C    ; $03; RPn tied to comparator 1C output
$define cOut_Fn_C1BOUT  2   ' CWG1B    ; $02; RPn tied to comparator 1B output
$define cOut_Fn_C1AOUT  1   ' CWG1A    ; $01; RPn tied to comparator 1A output
$define cOut_Fn_NULL    0   ' LATxy    ; $00; RPn tied to default port pPin 
$endif
'-------------------------------------------------------------------------------
' PPS Pin Outputs
'
$define cOut_Pin_RA0  RA0PPS    ' Assign OutFn to Output Pin RA0
$define cOut_Pin_RA1  RA1PPS    ' Assign OutFn to Output Pin RA1
$define cOut_Pin_RA3  RA2PPS    ' Assign OutFn to Output Pin RA2
$define cOut_Pin_RA3  RA3PPS    ' Assign OutFn to Output Pin RA3
$define cOut_Pin_RA4  RA4PPS    ' Assign OutFn to Output Pin RA4
$define cOut_Pin_RA5  RA5PPS    ' Assign OutFn to Output Pin RA5
$define cOut_Pin_RA6  RA6PPS    ' Assign OutFn to Output Pin RA6
$define cOut_Pin_RA7  RA7PPS    ' Assign OutFn to Output Pin RA7

$define cOut_Pin_RB0  RB0PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RB1  RB1PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RB2  RB2PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RB3  RB3PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RB4  RB4PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RB5  RB5PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RB6  RB6PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RB7  RB7PPS    ' Assign OutFn to Output Pin RA7

$define cOut_Pin_RC0  RC0PPS    ' Assign OutFn to Output Pin RC0
$define cOut_Pin_RC1  RC1PPS    ' Assign OutFn to Output Pin RC1
$define cOut_Pin_RC2  RC2PPS    ' Assign OutFn to Output Pin RC2
$define cOut_Pin_RC3  RC3PPS    ' Assign OutFn to Output Pin RC3
$define cOut_Pin_RC4  RC4PPS    ' Assign OutFn to Output Pin RC4
$define cOut_Pin_RC5  RC5PPS    ' Assign OutFn to Output Pin RC5
$define cOut_Pin_RC6  RC6PPS    ' Assign OutFn to Output Pin RC6
$define cOut_Pin_RC7  RC7PPS    ' Assign OutFn to Output Pin RC7

$if (_device = _18F47K40) Or (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cOut_Pin_RD0  RD0PPS    ' Assign OutFn to Output Pin RD0
$define cOut_Pin_RD1  RD1PPS    ' Assign OutFn to Output Pin RD1
$define cOut_Pin_RD2  RD2PPS    ' Assign OutFn to Output Pin RD2
$define cOut_Pin_RD3  RD3PPS    ' Assign OutFn to Output Pin RD3
$define cOut_Pin_RD4  RD4PPS    ' Assign OutFn to Output Pin RD4
$define cOut_Pin_RD5  RD5PPS    ' Assign OutFn to Output Pin RD5
$define cOut_Pin_RD6  RD6PPS    ' Assign OutFn to Output Pin RD6
$define cOut_Pin_RD7  RD7PPS    ' Assign OutFn to Output Pin RD7

$define cOut_Pin_RE0  RE0PPS    ' Assign OutFn to Output Pin RE0
$define cOut_Pin_RE1  RE1PPS    ' Assign OutFn to Output Pin RE1
$define cOut_Pin_RE2  RE2PPS    ' Assign OutFn to Output Pin RE2
$endif

$if (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cOut_Pin_RE3  RE3PPS    ' Assign OutFn to Output Pin RE3
$define cOut_Pin_RE4  RE4PPS    ' Assign OutFn to Output Pin RE4
$define cOut_Pin_RE5  RE5PPS    ' Assign OutFn to Output Pin RE5
$define cOut_Pin_RE6  RE6PPS    ' Assign OutFn to Output Pin RE6
$define cOut_Pin_RE7  RE7PPS    ' Assign OutFn to Output Pin RE7

$define cOut_Pin_RF0  RF0PPS    ' Assign OutFn to Output Pin RF0
$define cOut_Pin_RF1  RF1PPS    ' Assign OutFn to Output Pin RF1
$define cOut_Pin_RF2  RF2PPS    ' Assign OutFn to Output Pin RF2
$define cOut_Pin_RF3  RF3PPS    ' Assign OutFn to Output Pin RF3
$define cOut_Pin_RF4  RF4PPS    ' Assign OutFn to Output Pin RF4
$define cOut_Pin_RF5  RF5PPS    ' Assign OutFn to Output Pin RF5
$define cOut_Pin_RF6  RF6PPS    ' Assign OutFn to Output Pin RF6
$define cOut_Pin_RF7  RF7PPS    ' Assign OutFn to Output Pin RF7

$define cOut_Pin_RG0  RG0PPS    ' Assign OutFn to Output Pin RG0
$define cOut_Pin_RG1  RG1PPS    ' Assign OutFn to Output Pin RG1
$define cOut_Pin_RG2  RG2PPS    ' Assign OutFn to Output Pin RG2
$define cOut_Pin_RG3  RG3PPS    ' Assign OutFn to Output Pin RG3
$define cOut_Pin_RG4  RG4PPS    ' Assign OutFn to Output Pin RG4
'
$define cOut_Pin_RG6  RG6PPS    ' Assign OutFn to Output Pin RG6
$define cOut_Pin_RG7  RG7PPS    ' Assign OutFn to Output Pin RG7

$define cOut_Pin_RH0  RH0PPS    ' Assign OutFn to Output Pin RH0
$define cOut_Pin_RH1  RH1PPS    ' Assign OutFn to Output Pin RH1
$define cOut_Pin_RH2  RH2PPS    ' Assign OutFn to Output Pin RH2
$define cOut_Pin_RH3  RH3PPS    ' Assign OutFn to Output Pin RH3
$endif
'-------------------------------------------------------------------------------
' PPS Pin Outputs
'
$define cOut_Pin_RP0  RA0PPS    ' Assign OutFn to Output Pin RA0
$define cOut_Pin_RP1  RA1PPS    ' Assign OutFn to Output Pin RA1
$define cOut_Pin_RP3  RA2PPS    ' Assign OutFn to Output Pin RA2
$define cOut_Pin_RP3  RA3PPS    ' Assign OutFn to Output Pin RA3
$define cOut_Pin_RP4  RA4PPS    ' Assign OutFn to Output Pin RA4
$define cOut_Pin_RP5  RA5PPS    ' Assign OutFn to Output Pin RA5
$define cOut_Pin_RP6  RA6PPS    ' Assign OutFn to Output Pin RA6
$define cOut_Pin_RP7  RA7PPS    ' Assign OutFn to Output Pin RA7

$define cOut_Pin_RP8  RB0PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RP9  RB1PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RP10 RB2PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RP11 RB3PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RP12 RB4PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RP13 RB5PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RP14 RB6PPS    ' Assign OutFn to Output Pin RA7
$define cOut_Pin_RP15 RB7PPS    ' Assign OutFn to Output Pin RA7

$define cOut_Pin_RP16 RC0PPS    ' Assign OutFn to Output Pin RC0
$define cOut_Pin_RP17 RC1PPS    ' Assign OutFn to Output Pin RC1
$define cOut_Pin_RP18 RC2PPS    ' Assign OutFn to Output Pin RC2
$define cOut_Pin_RP19 RC3PPS    ' Assign OutFn to Output Pin RC3
$define cOut_Pin_RP20 RC4PPS    ' Assign OutFn to Output Pin RC4
$define cOut_Pin_RP21 RC5PPS    ' Assign OutFn to Output Pin RC5
$define cOut_Pin_RP22 RC6PPS    ' Assign OutFn to Output Pin RC6
$define cOut_Pin_RP23 RC7PPS    ' Assign OutFn to Output Pin RC7

$if (_device = _18F47K40) Or (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cOut_Pin_RP24 RD0PPS    ' Assign OutFn to Output Pin RC0
$define cOut_Pin_RP25 RD1PPS    ' Assign OutFn to Output Pin RC1
$define cOut_Pin_RP26 RD2PPS    ' Assign OutFn to Output Pin RC2
$define cOut_Pin_RP27 RD3PPS    ' Assign OutFn to Output Pin RC3
$define cOut_Pin_RP28 RD4PPS    ' Assign OutFn to Output Pin RC4
$define cOut_Pin_RP29 RD5PPS    ' Assign OutFn to Output Pin RC5
$define cOut_Pin_RP30 RD6PPS    ' Assign OutFn to Output Pin RC6
$define cOut_Pin_RP31 RD7PPS    ' Assign OutFn to Output Pin RC7

$define cOut_Pin_RP32 RE0PPS    ' Assign OutFn to Output Pin RC0
$define cOut_Pin_RP33 RE1PPS    ' Assign OutFn to Output Pin RC1
$define cOut_Pin_RP34 RE2PPS    ' Assign OutFn to Output Pin RC2
$endif

$if (_device = _18F65K40) Or (_device = _18F66K40) Or (_device = _18F67K40)
$define cOut_Pin_RP35  RE3PPS    ' Assign OutFn to Output Pin RE3
$define cOut_Pin_RP36  RE4PPS    ' Assign OutFn to Output Pin RE4
$define cOut_Pin_RP37  RE5PPS    ' Assign OutFn to Output Pin RE5
$define cOut_Pin_RP38  RE6PPS    ' Assign OutFn to Output Pin RE6
$define cOut_Pin_RP39  RE7PPS    ' Assign OutFn to Output Pin RE7

$define cOut_Pin_RP40  RF0PPS    ' Assign OutFn to Output Pin RF0
$define cOut_Pin_RP41  RF1PPS    ' Assign OutFn to Output Pin RF1
$define cOut_Pin_RP42  RF2PPS    ' Assign OutFn to Output Pin RF2
$define cOut_Pin_RP43  RF3PPS    ' Assign OutFn to Output Pin RF3
$define cOut_Pin_RP44  RF4PPS    ' Assign OutFn to Output Pin RF4
$define cOut_Pin_RP45  RF5PPS    ' Assign OutFn to Output Pin RF5
$define cOut_Pin_RP46  RF6PPS    ' Assign OutFn to Output Pin RF6
$define cOut_Pin_RP47  RF7PPS    ' Assign OutFn to Output Pin RF7

$define cOut_Pin_RP48  RG0PPS    ' Assign OutFn to Output Pin RG0
$define cOut_Pin_RP49  RG1PPS    ' Assign OutFn to Output Pin RG1
$define cOut_Pin_RP50  RG2PPS    ' Assign OutFn to Output Pin RG2
$define cOut_Pin_RP51  RG3PPS    ' Assign OutFn to Output Pin RG3
$define cOut_Pin_RP52  RG4PPS    ' Assign OutFn to Output Pin RG4
' 
$define cOut_Pin_RP54  RG6PPS    ' Assign OutFn to Output Pin RG6
$define cOut_Pin_RP55  RG7PPS    ' Assign OutFn to Output Pin RG7

$define cOut_Pin_RP56  RH0PPS    ' Assign OutFn to Output Pin RH0
$define cOut_Pin_RP57  RH1PPS    ' Assign OutFn to Output Pin RH1
$define cOut_Pin_RP58  RH2PPS    ' Assign OutFn to Output Pin RH2
$define cOut_Pin_RP59  RH3PPS    ' Assign OutFn to Output Pin RH3
$endif
'-------------------------------------------------------------------------------
' Assign a given Pin as an input Pin by configuring register xxxPPS
'
$define iPPSInput(pCinFn, pRPin) pCinFn = pRPin

(*
' Examples:
    iPPSInput(cIn_Fn_RX1DT1, cIn_Pin_RP23)  ' RX1 to RC7 input   
    OR
    iPPSInput(cIn_Fn_RX1DT1, cIn_Pin_RC7)   ' RX1 to RC7 input  
    OR
    RX1PPS = 23                             ' RX1 To RC7 Input    
*)
'-------------------------------------------------------------------------------
' Assign a given Pin as an output Pin by configuring register RxyPPS
'
$define iPPSOutput(pCoutPin, pCoutFn) pCoutPin = pCoutFn

(*
' Example:
    iPPSOutput(cOut_Pin_RP22, cOut_Fn_TX1CK1)   ' RC6 output from TX1
    OR
    iPPSOutput(cOut_Pin_RC6, cOut_Fn_TX1CK1)    ' RC6 output from TX1
    OR
    RC6PPS = 9                                  ' RC6 output from TX1
*)
'-------------------------------------------------------------------------------
' Perform the unlocking sequence for PPS assignment
' Input     : None
' Output    : None
'
$define PPS_EnableWrite()        '
    #ifdef __INTERRUPTS_ENABLED  '
    PRODH = INTCON               '
    INTCONBits_GIE = 0           '
    #endif                       '
    PPSLOCK = $55                '
    PPSLOCK = $AA                '
    PPSLOCK.0 = 0

'-------------------------------------------------------------------------------
' Perform the locking sequence for PPS assignment
' Input     : None
' Output    : None
'
$define PPS_DisableWrite()       '
    PPSLOCK = $55                '
    PPSLOCK = $AA                '
    PPSLOCK.0 = 1                '
    #ifdef __INTERRUPTS_ENABLED  '
    If PRODH.7 = 1 Then          '
        INTCONBits_GIE = 1       ' 
    EndIf                        '
    #endif

'===============================================================================
$endif
    
